unit ml_menu;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Sockets, Menus, ML_options, about;

const MetamoLaunchVersion = '0.1.7';

type
  TMainForm = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    TcpClient1: TTcpClient;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    H1: TMenuItem;
    O1: TMenuItem;
    Abaout1: TMenuItem;
    F1: TMenuItem;
    X1: TMenuItem;
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TcpClient1Connect(Sender: TObject);
    procedure X1Click(Sender: TObject);
    procedure O1Click(Sender: TObject);
    procedure Abaout1Click(Sender: TObject);

  private
    { Private 錾 }

  public

    { Public 錾 }
  end;

var
  MainForm: TMainForm;


implementation

uses myThread;

{$R *.dfm}

var
  pi2: TProcessInformation;
  pi3: TProcessInformation;
  pi4: TProcessInformation;
  pi6: TProcessInformation;
  FSPORT: PAnsiChar;
  XDMCPPORT: PAnsiChar;
  SSHPORT: PAnsiChar;
  xdmcpConnected: bool;
  xdmcpAbadoned: bool;
  SocThread: TSocThread;


function EnumWindowsProc(hwnd : THandle; lParam : longint):BOOL; stdcall;
var
  dwProcessId : integer;
begin
  Result := true;
  GetWindowThreadProcessId(hwnd,@dwProcessId);
  if dwProcessId=lParam then begin
    SendMessage(hwnd, WM_CLOSE, 0, 0);
    Result := false;
  end;
end;

procedure TMainForm.Button6Click(Sender: TObject);
var
  ret: Boolean;
  ecode,i: Integer;
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
begin
  if pi6.dwProcessId = 0 then
  begin
    FillChar(StartupInfo,SizeOf(TStartupInfo),#0);
    FillChar(ProcessInfo,SizeOf(TProcessInformation),#0);
    StartupInfo.cb := SizeOf(TStartupInfo);
    StartupInfo.dwFlags := STARTF_USESHOWWINDOW;

    SetEnvironmentVariable('TMP','/tmp');
    SetEnvironmentVariable('HOME','.');
    StartupInfo.wShowWindow := SW_HIDE;
    ret := CreateProcess(
      nil,                        // st@C
      PAnsiChar(Options.ime_loc + ' -inet -f'),              // R}hC
      nil,                        // vZX̃ZLeB
      nil,                        // Xbh̃ZLeB
      False,                      // evZXnhp邩
      CREATE_DEFAULT_ERROR_MODE
      +CREATE_NEW_PROCESS_GROUP
      +NORMAL_PRIORITY_CLASS,     // D揇ʂƃvZX̐쐧
      nil,                        // ϐubNւ̃|C^
      nil,                        // JgfBNg
      StartupInfo,                // EBhȆ
      ProcessInfo                 // VvZX̏󂯎\
      );
      // G[`FbN
    if not ret then
      ShowMessage('sł܂ (' + IntToStr(GetLastError) + ')')
    else
    begin
      pi6 := ProcessInfo;
      Button6.Font.Style := [fsBold];
      Application.ProcessMessages;
      if Sender <> nil then
      begin
      repeat
        ecode := WaitForSingleObject(ProcessInfo.hProcess, 100);
        if ecode = WAIT_OBJECT_0 then break;
        Application.ProcessMessages;
      until FALSE;
      Button6.Font.Style := [];
      Application.ProcessMessages;
      pi6.dwProcessId := 0;
      end;
    end;
  end
  else
  begin
    EnumWindows(@EnumWindowsProc,pi6.dwProcessId);
     for i:=0 to 600 do
     begin
      ecode := WaitForSingleObject(pi6.hProcess, 100);
      if ecode = WAIT_OBJECT_0 then break;
      Application.ProcessMessages;
     end;
     TerminateProcess(pi6.hProcess, 0);
    pi6.dwProcessId := 0;
  end;
end;


procedure TMainForm.Button4Click(Sender: TObject);
var
  ret: Boolean;
  ecode,i: Integer;
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
begin
  if pi4.dwProcessId = 0 then
  begin
    FillChar(StartupInfo,SizeOf(TStartupInfo),#0);
    FillChar(ProcessInfo,SizeOf(TProcessInformation),#0);
    StartupInfo.cb := SizeOf(TStartupInfo);
    StartupInfo.dwFlags := STARTF_USESHOWWINDOW;

    StartupInfo.wShowWindow := SW_HIDE;
    ret := CreateProcess(
      nil,                        // st@C
      PAnsiChar(Options.esd_loc + ' -tcp -public -nobeeps'),              // R}hC
      nil,                        // vZX̃ZLeB
      nil,                        // Xbh̃ZLeB
      False,                      // evZXnhp邩
      CREATE_DEFAULT_ERROR_MODE
      +CREATE_NEW_PROCESS_GROUP
      +NORMAL_PRIORITY_CLASS,     // D揇ʂƃvZX̐쐧
      nil,                        // ϐubNւ̃|C^
      nil,                        // JgfBNg
      StartupInfo,                // EBhȆ
      ProcessInfo                 // VvZX̏󂯎\
    );
    // G[`FbN
    if not ret then
    begin
      ShowMessage('sł܂ (' + IntToStr(GetLastError) + ')');
       pi4 := ProcessInfo;
       pi4.dwProcessId := 0;
    end
    else
    begin
      pi4 := ProcessInfo;
      Button4.Font.Style := [fsBold];
      Application.ProcessMessages;
      if Sender <> nil then
      begin
      repeat
        ecode := WaitForSingleObject(ProcessInfo.hProcess, 100);
        if ecode = WAIT_OBJECT_0 then break;
        Application.ProcessMessages;
      until FALSE;
      pi4.dwProcessId := 0;
      Button4.Font.Style := [];
      Application.ProcessMessages;
      end;
    end;
  end
  else
  begin
     EnumWindows(@EnumWindowsProc, pi4.dwProcessId);
     for i:=0 to 600 do
     begin
      ecode := WaitForSingleObject(pi4.hProcess, 100);
      if ecode = WAIT_OBJECT_0 then break;
      Application.ProcessMessages;
     end;
     TerminateProcess(pi4.hProcess, 0);
     pi4.dwProcessId := 0;
  end;
end;

procedure TMainForm.Button3Click(Sender: TObject);

var
  ret: Boolean;
  ecode: Integer;
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
  i,j : Integer;
  Command: String;
begin
  ret := false;

  if pi3.dwProcessId = 0 then
  begin
    FillChar(StartupInfo,SizeOf(TStartupInfo),#0);
    FillChar(ProcessInfo,SizeOf(TProcessInformation),#0);
    StartupInfo.cb := SizeOf(TStartupInfo);
    StartupInfo.dwFlags := STARTF_USESHOWWINDOW;

{
    StartupInfo.wShowWindow := SW_HIDE;
    //ret :=
    CreateProcess(
      nil,                        // st@C
      PAnsiChar('ping -w 10000 '+OptionForm.server_ip),
                  // R}hC
      nil,                        // vZX̃ZLeB
      nil,                        // Xbh̃ZLeB
      False,                      // evZXnhp邩
      CREATE_DEFAULT_ERROR_MODE
      +CREATE_NEW_PROCESS_GROUP
      +NORMAL_PRIORITY_CLASS,     // D揇ʂƃvZX̐쐧
      nil,                        // ϐubNւ̃|C^
      nil,                        // JgfBNg
      StartupInfo,                // EBhȆ
      ProcessInfo                 // VvZX̏󂯎\
    );
    // G[`FbN
    //if not ret then
    //  ShowMessage('sł܂ (' + IntToStr(GetLastError) + ')');
    WaitForSingleObject(ProcessInfo.hProcess, INFINITE);
}
    xdmcpConnected := false;
    xdmcpAbadoned := false;
    for i := 0 to 60 do
    begin
      TcpClient1.RemoteHost := options.server_ip;
      TcpClient1.RemotePort := options.alck_port;
      SocThread := TSocThread.Create(false);
      if xdmcpConnected or xdmcpAbadoned  then break;
      for j := 0  to 10 do
      begin
        Sleep(100);
        Application.ProcessMessages;
      end;
    end;

    if xdmcpConnected then
    begin
      SetEnvironmentVariable('TMP', PAnsiChar(ExtractFileDir(Options.xm_loc)));
      SetEnvironmentVariable('TEMP', PAnsiChar(ExtractFileDir(Options.xm_loc)));
      SetEnvironmentVariable('HOME', PAnsiChar(ExtractFileDir(Options.xm_loc)));
      StartupInfo.wShowWindow := SW_SHOWNORMAL;

      Command := Options.xm_loc+'  ' + Options.Xm_optionline;
      if  Options.use_XDMCP then
      Command := Command + ' -query '
        +Options.server_ip+' -from '+Options.client_ip;
      if Options.use_xfs then
        Command := Command +' -fp "tcp/'+Options.xfs_ip+':'+Options.xfs_port+'"';

      ret := CreateProcess(
        nil,                        // st@C
        PAnsiChar(Command),         // R}hC
        nil,                        // vZX̃ZLeB
        nil,                        // Xbh̃ZLeB
        False,                      // evZXnhp邩
        CREATE_DEFAULT_ERROR_MODE
        +CREATE_NEW_PROCESS_GROUP
        +NORMAL_PRIORITY_CLASS,     // D揇ʂƃvZX̐쐧
        nil,                        // ϐubNւ̃|C^
        nil,                        // JgfBNg
        StartupInfo,                // EBhȆ
        ProcessInfo                 // VvZX̏󂯎\
      );
    end;
    // G[`FbN
    if not (xdmcpConnected and ret) then
      ShowMessage('Xmingss (' + IntToStr(GetLastError) + ')')
    else
    begin
      pi3 := ProcessInfo;
      Button3.Font.Style := [fsBold];
      Application.ProcessMessages;
      if Sender <> nil then
      begin
       repeat
          ecode := WaitForSingleObject(ProcessInfo.hProcess, 100);
          if ecode = WAIT_OBJECT_0 then break;
          Application.ProcessMessages;
       until FALSE;
       pi3.dwProcessId := 0;
       Button3.Font.Style := [];
       Application.ProcessMessages;
      end;
    end;
  end
  else
  begin
     EnumWindows(@EnumWindowsProc, pi3.dwProcessId);
     for i:=0 to 600 do
     begin
      ecode := WaitForSingleObject(pi3.hProcess, 100);
      if ecode = WAIT_OBJECT_0 then break;
      Application.ProcessMessages;
     end;
     TerminateProcess(pi3.hProcess, 0);
     pi3.dwProcessId := 0;
  end;
end;

procedure TMainForm.Button2Click(Sender: TObject);

var
  ret: Boolean;
  ecode,i: Integer;
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
  Command: String;
begin
  if pi2.dwProcessId = 0 then
  begin
    FillChar(StartupInfo,SizeOf(TStartupInfo),#0);
    FillChar(ProcessInfo,SizeOf(TProcessInformation),#0);
    StartupInfo.cb := SizeOf(TStartupInfo);
    StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
    StartupInfo.wShowWindow := SW_SHOWMINNOACTIVE;
    Command := Options.co_loc + ' -c ' + Options.colinux_xml;
    if Options.cl_terminal then
    Command := Command + ' -t nt'
    else
    Command := Command + ' -d';
    ret := CreateProcess(
      nil,                        // st@C
      PAnsiChar(Command),         // R}hC
      nil,                        // vZX̃ZLeB
      nil,                        // Xbh̃ZLeB
      False,                      // evZXnhp邩
      CREATE_DEFAULT_ERROR_MODE
      +CREATE_NEW_PROCESS_GROUP
      +NORMAL_PRIORITY_CLASS,     // D揇ʂƃvZX̐쐧
      nil,                        // ϐubNւ̃|C^
      nil,                        // JgfBNg
      StartupInfo,                // EBhȆ
      ProcessInfo                 // VvZX̏󂯎\
    );
    // G[`FbN
    if not ret then
      ShowMessage('sł܂ (' + IntToStr(GetLastError) + ')')
    else
    begin
      pi2 := ProcessInfo;
      Button2.Font.Style := [fsBold];
      Application.ProcessMessages;
      if Sender <> nil then
      begin
      repeat
        ecode := WaitForSingleObject(ProcessInfo.hProcess, 100);
        if ecode = WAIT_OBJECT_0 then break;
          Application.ProcessMessages;
      until FALSE;
      Button2.Font.Style := [];
      Application.ProcessMessages;
      pi2.dwProcessId := 0;
      end;
    end;
  end
  else
  begin
     EnumWindows(@EnumWindowsProc, pi2.dwProcessId);
     for i:=0 to 600 do
     begin
      ecode := WaitForSingleObject(pi2.hProcess, 100);
      if ecode = WAIT_OBJECT_0 then break;
      Application.ProcessMessages;
     end;
     TerminateProcess(pi2.hProcess, 0);
     pi2.dwProcessId := 0;
  end;
end;

procedure TMainForm.Button1Click(Sender: TObject);

var
  DummySender: TObject;
  ecode2: Integer;
  ecode3: Integer;
  ecode4: Integer;
  ecode6: Integer;
begin
  DummySender := nil;
  ecode2 := 1;
  ecode3 := 1;
  ecode4 := 1;
  ecode6 := 1;
  if pi2.dwProcessId = 0 then MainForm.Button2Click(DummySender);
  if pi3.dwProcessId = 0 then MainForm.Button3Click(DummySender);
  if pi4.dwProcessId = 0 then MainForm.Button4Click(DummySender);
  if pi6.dwProcessId = 0 then MainForm.Button6Click(DummySender);

  if pi2.dwProcessId = 0 then ecode2 := WAIT_OBJECT_0;
  if pi3.dwProcessId = 0 then ecode3 := WAIT_OBJECT_0;
  if pi4.dwProcessId = 0 then ecode4 := WAIT_OBJECT_0;
  if pi6.dwProcessId = 0 then ecode6 := WAIT_OBJECT_0;

  repeat
    if ecode2 <> WAIT_OBJECT_0 then
      ecode2 := WaitForSingleObject(pi2.hProcess, 100);
    if ecode2 = WAIT_OBJECT_0 then
    begin
      pi2.dwProcessId := 0;
      Button2.Font.Style := [];
      Application.ProcessMessages;
    end;
    Application.ProcessMessages;
    if ecode3 <> WAIT_OBJECT_0 then
      ecode3 := WaitForSingleObject(pi3.hProcess, 100);
    if ecode3 = WAIT_OBJECT_0 then
    begin
      pi3.dwProcessId := 0;
      Button3.Font.Style := [];
      Application.ProcessMessages;
    end;
    Application.ProcessMessages;
    if ecode4 <> WAIT_OBJECT_0 then
      ecode4 := WaitForSingleObject(pi4.hProcess, 100);
    if ecode4 = WAIT_OBJECT_0 then
    begin
      pi4.dwProcessId := 0;
      Button4.Font.Style := [];
      Application.ProcessMessages;
    end;
    Application.ProcessMessages;
    if ecode6 <> WAIT_OBJECT_0 then
      ecode6 := WaitForSingleObject(pi6.hProcess, 100);
    if ecode6 = WAIT_OBJECT_0 then
    begin
      pi6.dwProcessId := 0;
      Button6.Font.Style := [];
      Application.ProcessMessages;
    end;
    Application.ProcessMessages;
    if (ecode2 = WAIT_OBJECT_0)
      and (ecode3 = WAIT_OBJECT_0)
      and ( ecode4 = WAIT_OBJECT_0)
      and ( ecode6 = WAIT_OBJECT_0) then break;
  until false;
end;

procedure TMainForm.Button5Click(Sender: TObject);
begin
  if not (pi6.dwProcessId = 0) then Button6.Click;
  if not (pi4.dwProcessId = 0) then Button4.Click;
  xdmcpAbadoned := true;
  if not (pi3.dwProcessId = 0) then Button3.Click;
  if not (pi2.dwProcessId = 0) then Button2.Click;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Options.WriteInifile;
  MainForm.Button5Click(Sender);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Options.WriteInifile;
  MainForm.Button5Click(Sender);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
   pi2.dwProcessId := 0;
   pi3.dwProcessId := 0;
   pi4.dwProcessId := 0;
   pi6.dwProcessId := 0;
   FSPORT := '7100';
   XDMCPPORT := '177';
   SSHPORT := '22';
end;


procedure TMainForm.TcpClient1Connect(Sender: TObject);
begin
   xdmcpConnected := true;
end;

procedure TMainForm.X1Click(Sender: TObject);
begin
  MainForm.Close;
end;

procedure TMainForm.O1Click(Sender: TObject);
begin
  OptionForm.Show;
end;

procedure TMainForm.Abaout1Click(Sender: TObject);
begin
  AboutBox.Show;
end;
{
    MetamoLaunch, the Metamo Linux launcher for Windows 2000 & XP
    Copyright (C) 2005 Keishi Suenaga.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}
End.
